# CompanyFinancesWindow Struct Reference

Window class displaying the company finances. More...

Inheritance diagram for CompanyFinancesWindow:

## Public Member Functions
| CompanyFinancesWindow (const WindowDesc *desc, CompanyID company)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
void | SetupWidgets ()
| Setup the widgets in the nested tree, such that the finances window is displayed properly.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks.
## Data Fields
bool | small
| Window is toggled to 'small'.
## Static Public Attributes
static Money | max_money = INT32_MAX
| The maximum amount of money a company has had this 'run'.

## Detailed Description

Window class displaying the company finances.

Todo:
  money_width should be calculated dynamically.

Definition at line 286 of file company_gui.cpp.

## Member Function Documentation

virtual void CompanyFinancesWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 346 of file company_gui.cpp.

References _cur_year, CFW_BALANCE_VALUE, CFW_EXPS_CATEGORY, CFW_EXPS_PRICE1, CFW_EXPS_PRICE2, CFW_EXPS_PRICE3, CFW_LOAN_LINE, CFW_LOAN_VALUE, CFW_TOTAL_VALUE, DrawCategories(), DrawString(), DrawYearColumn(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::Get(), GfxFillRect(), min(), SA_RIGHT, SetDParam(), and Window::window_number.

virtual void CompanyFinancesWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 436 of file company_gui.cpp.

References _ctrl_pressed, CFW_INCREASE_LOAN, CFW_REPAY_LOAN, CFW_TOGGLE_SIZE, CMD_DECREASE_LOAN, CMD_INCREASE_LOAN, CMD_MSG, DoCommandP(), Window::IsShaded(), Window::ReInit(), Window::SetShaded(), SetupWidgets(), and small.

virtual void CompanyFinancesWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 406 of file company_gui.cpp.

References _settings_client, CFW_EXPS_CATEGORY, CFW_INCREASE_LOAN, CFW_REPAY_LOAN, CFW_SEL_BUTTONS, Window::DrawWidgets(), GUISettings::expenses_layout, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_company_pool >::Get(), ClientSettings::gui, Window::IsShaded(), Economy::max_loan, Window::ReInit(), SetupWidgets(), Window::SetWidgetDisabledState(), small, SZSP_NONE, and Window::window_number.

virtual void CompanyFinancesWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 300 of file company_gui.cpp.

References CFW_CAPTION, CFW_INCREASE_LOAN, CFW_MAXLOAN_VALUE, CFW_REPAY_LOAN, LOAN_INTERVAL, Economy::max_loan, SetDParam(), and Window::window_number.

void CompanyFinancesWindow::SetupWidgets | ( |  | ) | `[inline]`

Setup the widgets in the nested tree, such that the finances window is displayed properly.

Note:
  After setup, the window must be (re-)initialized.

Definition at line 395 of file company_gui.cpp.

References CFW_SEL_BUTTONS, CFW_SEL_MAXLOAN, CFW_SEL_PANEL, small, SZSP_NONE, and Window::window_number.

Referenced by OnClick(), OnHundredthTick(), and OnPaint().

virtual void CompanyFinancesWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 319 of file company_gui.cpp.

References _settings_client, CFW_BALANCE_VALUE, CFW_EXPS_CATEGORY, CFW_EXPS_PRICE1, CFW_EXPS_PRICE2, CFW_EXPS_PRICE3, CFW_LOAN_VALUE, CFW_MAXLOAN_GAP, CFW_TOTAL_VALUE, GUISettings::expenses_layout, FONT_HEIGHT_NORMAL, ExpensesList::GetCategoriesWidth(), GetStringBoundingBox(), ClientSettings::gui, max(), max_money, SetDParam(), and Window::width.

## Field Documentation

Money CompanyFinancesWindow::max_money = INT32_MAX`[static]`

The maximum amount of money a company has had this 'run'.

First conservative estimate of the maximum amount of money.

Definition at line 287 of file company_gui.cpp.

Referenced by OnHundredthTick(), and UpdateWidgetSize().

The documentation for this struct was generated from the following file:

- src/company_gui.cpp